/* SR3C, a symbol ranking data compressor.
 *
 * A simple uncompressor from stdin to stdout.
 *
 * Author: Kenneth Oksanen <cessu@iki.fi>, 2008.
 * Copyright (C) Helsinki University of Technology.
 *
 * This file is distributed under the following license:

The MIT License
Copyright (c) 2008 Helsinki University of Technology
Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

 */


#include <stdio.h>
#include <unistd.h>
#include "sr3c.h"


static int write_f(const unsigned char *bytes, size_t n_bytes, 
		   int flush, void *ctx)
{
  return fwrite(bytes, 1, n_bytes, stdout) == n_bytes ? 0 : -1;
}


int main(void)
{
  sr3c_context_t *ctx;
  size_t n;
  unsigned char buf[10000];
  int i, j;

  ctx = sr3c_alloc(write_f, NULL);

  while (!feof(stdin) && !ferror(stdin)) {
    n = fread(buf, 1, sizeof(buf), stdin);
    sr3c_uncompress(buf, n, ctx);
  }

  sr3c_free(ctx);

  return 0;
}
